#include "CBG.h"

CBG::CBG()
{
	// 摜̓ǂݍ
	m_BackGroundModel.LoadImage( "pictures/space.jpg", 0 );
	m_StarModels[0].LoadImage( "pictures/star.png" );

	Init();
}

void CBG::Init()
{
	for ( int i = 0; i < MAX_STAR; i++ )
		m_Stars[i].m_bActive = false;
}

bool CBG::Add( float x, float y, float vx, float vy, int Color, char type )
{
	int index = GetEmptyObjectIndex();
	if ( index < 0 ) return false;

	STAR_OBJECT *pObj = &m_Stars[index];
	pObj->m_bActive = true;
	
	pObj->m_Pos.x = x;
	pObj->m_Pos.y = y;
	pObj->m_V.x = vx;
	pObj->m_V.y = vy;
	
	pObj->m_Color = Color;
	pObj->type = type;

	return true;
}

bool CBG::AddStar()
{
	// ̒ǉ
	return Add( rand() % SCREEN_WIDTH, rand() % 200,
				50 - rand() % 100, 100 + rand() % 200, 0, 0 );
}

int CBG::GetEmptyObjectIndex()
{
	// ܂ANeBuɂȂĂȂIuWFNg{
	for ( int i = 0; i < MAX_STAR; i++ ) {
		if ( m_Stars[i].m_bActive == false )
			return i;
	}

	return -1;
}

bool CBG::Act()
{
	for ( int i = 0; i < MAX_STAR; i++ ) {
		if ( m_Stars[i].m_bActive ) {
			
			// o̎̐Fݒ
			if ( m_Stars[i].m_Color < 255 ) {
				m_Stars[i].m_Color += FTIME * 255;
				if ( m_Stars[i].m_Color > 255 ) m_Stars[i].m_Color = 255;
			}

			// ʊOɂł
			if ( m_Stars[i].m_Pos.y >= SCREEN_HEIGHT ||
				 m_Stars[i].m_Pos.x <= -100 ||
				 m_Stars[i].m_Pos.x >= SCREEN_WIDTH ) {
				m_Stars[i].m_bActive = false;
			}

			// ړ
			m_Stars[i].m_Pos.x += FTIME * m_Stars[i].m_V.x;
			m_Stars[i].m_Pos.y += FTIME * m_Stars[i].m_V.y;
		}
	}

	return true;
}

bool CBG::Draw()
{
	m_BackGroundModel.Draw( 0, 0 );	// wi`

	for ( int i = 0; i < MAX_STAR; i++ ) {
		// ANeBuȂ
		if ( m_Stars[i].m_bActive ) {

			int type = m_Stars[i].type;
			// F̐ݒ
			m_StarModels[type].SetColor( BLEND_ADD, 
				COLOR_ARGB( (int) m_Stars[i].m_Color, 255, 255, 255 ) );
			// ̕`
			m_StarModels[type].Draw( m_Stars[i].m_Pos.x, m_Stars[i].m_Pos.y );
		}
	}

	return true;
}
