#include "DxApp.h"
#include "GameSetting.h"
#include "CModel.h"

#define MAX_STAR 20

#pragma once

struct STAR_OBJECT
{
	bool m_bActive;
	D3DXVECTOR2 m_Pos;
	D3DXVECTOR2 m_V;	// Velocity : x
	float m_Color;
	char type;
};

class CBG
{
public:
	CBG();
	virtual ~CBG() {};

	void Init();	// 
	bool Act();		// wiAj[V
	bool Add( float x, float y, float vx, float vy, int Color, char type ); // 
	bool AddStar();
	bool Draw();	// wi̕`

	int GetEmptyObjectIndex();

private:
	CModel m_BackGroundModel;
	CModel m_StarModels[1];
	STAR_OBJECT m_Stars[MAX_STAR];
//	SPROBJ m_BackGround;
//	STAR_OBJECT m_Stars[MAX_STAR];
};