#pragma once

#include "DxApp.h"
#include "CModel.h"

#define MAX_BLASTS 32

struct BLAST_OBJECT
{
	bool m_bActive;
	D3DXVECTOR2 m_Pos;
	float m_fMotionTime;
	float m_fMotionColorValue;	// F̌vZl
	float m_fMotionScaleValue;	// XP[ǑvZl
	float m_fScale;
	char type;
};

class CBlast
{
public:
	CBlast();
	virtual ~CBlast() {};

	void Init();

	// Aj[V
	bool Act();
	// ̕`
	bool Draw();
	// Aj[V̒ǉ
	bool Add( float x, float y, float fMotionTime, float fScale, char type );

protected:
	int GetEmptyObjectIndex();
	void DrawObject( BLAST_OBJECT *pObj );

	CModel m_Model[2];
	BLAST_OBJECT m_BlastObjects[MAX_BLASTS];
};