#pragma once

#include "DxApp.h"
#include "GameSetting.h"
#include "CModel.h"
#include "CShip.h"
#include "CShots.h"
#include "CBlast.h"
#include "CGameSound.h"
#include "CScore.h"

#define MAX_ENEMIES 20

struct ENEMY_OBJECT
{
	bool m_bActive;
	D3DXVECTOR2 m_Pos;
	D3DXVECTOR2 m_CentralPos;
	char type;
	char m_cHP;
	int	m_iFrameCount;
	D3DXVECTOR2 m_V;
	char m_RotateDir;
	float m_fRotationAngle;
};

class CEnemies
{
public:
	CEnemies();
	virtual ~CEnemies() {}

	bool Init();

	// ׂĂ̓G̈ړ
	// GvC[ւ̍U
	bool Act( class CShip *pShip, CShots *pShots, CBlast *pBlast, CGameSound *pSound,
			  CScore *pScore );
	// ׂĂ̓G̕`
	bool Draw();
	// Gǉ
	bool Add( float x, float y, float vx, float vy, char type );
	// 蔻
	bool HitCheck( float x, float y, RECT HitRect );
	int GetEmptyObjectIndex();

private:
	CModel m_Models[2];
	CModel m_FireModels[2];

	ENEMY_OBJECT m_EnemyObjects[MAX_ENEMIES];

	int m_Score;
};
