#pragma once

#include "DxApp.h"

class CModel
{
public:
	CModel();
	virtual ~CModel() {}

	bool Draw( float x, float y, float z = 0 );
	bool LoadImage( char *filename, D3DCOLOR color = COLOR_XRGB(255,0,128) );
	bool DuplicateImage( CModel model );
	bool SetTextureRect( int x, int y, int sizex, int sizey );
	SPROBJ GetSprobj() { return m_Sprobj; }
	void SetHitRect( int x, int y, int x2, int y2 );
	RECT GetHitRect() { return m_HitRect; }
	bool HitCheck( float px, float py, RECT HitRect, float px2, float py2 );
	bool SetColor( BLEND_MODE mode, D3DXCOLOR color );
	bool SetScale( float sx, float sy );
	RECT GetTextureRect();

protected:
	SPROBJ m_Sprobj;
	RECT m_HitRect;
};