#pragma once

#include "DxApp.h"
#include "GameSetting.h"
#include "CModel.h"

#define MAX_SHOTS 800

enum SHOT_TYPE
{
	SHOT_MACHINEGUN,
	SHOT_MISSILE
};

struct SHOT_OBJECT
{
	bool m_bActive;
	D3DXVECTOR2 m_Pos;
	D3DXVECTOR2 m_Speed;
	SHOT_TYPE type;
};

class CShots
{
public:
	CShots();
	virtual ~CShots() {};

	bool Init();

	// ׂĂ̒ëړ
	// ʊOɂłeIɍ폜
	bool Act();
	// ׂĂ̒e̕`
	bool Draw();
	// e̒ǉ
	bool Add( float x, float y, float vx, float vy, SHOT_TYPE type );
	// vC[̒eǉ
	bool AddPlayerShot( float x, float y );
	bool AddPlayerShot2( float x, float y );
	// G̒eǉ
	bool AddEnemyNormalShot( float x, float y, D3DXVECTOR2 vTargetPos );
	// 蔻
	bool HitCheck( float x, float y, RECT HitArea, SHOT_TYPE ShotType, bool bEraseShot );

	int GetEmptyObjectIndex();

private:
	CModel m_Models[2];
	SHOT_OBJECT m_ShotObjects[MAX_SHOTS];
};