// {IuWFNg\
struct STDOBJ {
	int n;
	STDOBJ() { n = -1; }
	bool operator ==( STDOBJ obj ) {
		if ( this->n == obj.n ) return true;
		return false;
	}
	bool operator !=( STDOBJ obj ) {
		if ( this->n != obj.n ) return true;
		return false;
	}
};

//-----------------------------------------------------------------------------
// Name : CObjectArray NX
// Desc : IuWFNgi[Ǘ
//-----------------------------------------------------------------------------
template <typename TYPE>
class CObjectArray {
private:
	std::vector<TYPE*> m_Array;

public:
	void	Create( STDOBJ &obj );			// IuWFNg쐬zɒǉ
	bool	Delete( STDOBJ &obj );			// 폜
	void	AllDelete();					// ׂč폜
	bool	Check( STDOBJ obj );			// `FbN
	TYPE*	GetpObject( STDOBJ obj );		// IuWFNg̎擾
	TYPE*	GetpObject( int n );			// IuWFNg̎擾
	void	GetSize( int &n );				// ̎擾

	CObjectArray() {};
	virtual ~CObjectArray();
};

//-----------------------------------------------------------------------------
// Name : ~CObjectArray()
//-----------------------------------------------------------------------------
template <typename TYPE>
CObjectArray<TYPE>::~CObjectArray()
{
	AllDelete();
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : IuWFNg𐶐Ĕzɂ
//-----------------------------------------------------------------------------
template <typename TYPE>
void CObjectArray<TYPE>::Create( STDOBJ &obj )
{
	TYPE *pType = new TYPE();

	// 폜
	Delete( obj );

	int n = -1;
	for ( int i = 0; i < m_Array.size(); i++ ) {
		if ( m_Array[i] == 0 ) {
			n = i;
			break;
		}
	}

	if ( n == -1 ) {
		m_Array.push_back( pType );
		obj.n = m_Array.size() - 1;		
	}
	else {
		m_Array[i] = pType;
		obj.n = n;
	}
}

//-----------------------------------------------------------------------------
// Name : Check()
// Desc : IuWFNg̃`FbN
//-----------------------------------------------------------------------------
template <typename TYPE>
bool CObjectArray<TYPE>::Check( STDOBJ obj )
{
	if ( obj.n >= 0 && obj.n < m_Array.size() ) {
		if ( m_Array[ obj.n ] )
			return true;
	}
	return false;	
}

//-----------------------------------------------------------------------------
// Name : Delete()
// Desc : IuWFNg̍폜
//-----------------------------------------------------------------------------
template <typename TYPE>
bool CObjectArray<TYPE>::Delete( STDOBJ &obj )
{
	if ( Check( obj ) ) {
		SAFE_DELETE( m_Array[obj.n] );
		obj.n = -1;
		return true;
	}
	return false;
}

//-----------------------------------------------------------------------------
// Name : AllDelete()
// Desc : ׂẴIuWFNg̍폜
//-----------------------------------------------------------------------------
template <typename TYPE>
void CObjectArray<TYPE>::AllDelete()
{
	for ( int i = 0; i < m_Array.size(); i++ ) {
		if ( m_Array[i] )
			SAFE_DELETE( m_Array[i] );
	}
}

//-----------------------------------------------------------------------------
// Name : GetpObject()
// Desc : IuWFNg̎擾
// Rtn  : IuWFNgE|C^
//-----------------------------------------------------------------------------
template <typename TYPE>
TYPE* CObjectArray<TYPE>::GetpObject( STDOBJ obj )
{
	if ( Check( obj ) ) return m_Array[obj.n];
	return 0;
}

//-----------------------------------------------------------------------------
// Name : GetpObject()
// Desc : IuWFNg̎擾
// Rtn  : IuWFNgE|C^
//-----------------------------------------------------------------------------
template <typename TYPE>
TYPE* CObjectArray<TYPE>::GetpObject( int n )
{
	static STDOBJ obj;
	obj.n = n;
	if ( Check( obj ) ) return m_Array[n];
	return 0;
}

//-----------------------------------------------------------------------------
// Name : GetSize()
// Desc : IuWFNg̐̎擾
// Rtn  : IuWFNg̐
//-----------------------------------------------------------------------------
template <typename TYPE>
void CObjectArray<TYPE>::GetSize( int &n )
{
	n = m_Array.size();
}
