#ifndef _CD3D_H_
#define _CD3D_H_

//-----------------------------------------------------------------------------
// Name : CD3DNX
// Desc : Direct3D ֘Ȁs
//-----------------------------------------------------------------------------
class CD3D
{
private:
	HWND					m_hWnd;			// nh
	LPDIRECT3D9				m_pD3D;			// Direct3D C^[tFCX
	LPDIRECT3DDEVICE9		m_pD3DDev;		// Direct3D foCX
	D3DPRESENT_PARAMETERS	m_d3dpp;		// Direct3D p[^
	D3DPRESENT_PARAMETERS	m_d3dppWindow;	// EBhEEp[^
	D3DPRESENT_PARAMETERS	m_d3dppFull;	// tXN[Ep[^
	bool					m_bDeviceLost;	// foCX̏tO
	bool					m_bChangeWindow;	// EBhEύXꂽ

	bool					m_bVSync;		// tO

public:
	~CD3D();
	CD3D();

	bool	InitD3DObject();	// D3D IuWFNg̏

	// XN[̍쐬
	bool	Init( HWND hWnd, int x, int y, D3DFORMAT *ZBufferFormat, 
				 bool bWindowMode );

	bool	Begin();						// V[̊Jn
	void	Render();						// V[̕`
	void	ClearScene( D3DCOLOR color );	// V[̃NA

	bool	CreateDevice();						// Direct3D foCX̍쐬
	bool	SetViewport();						// r[|[g̐ݒ
	void	SetBackBufferSize( int x, int y );	// BackBufferTCY̐ݒ
	void	SetWindowParam( bool bl );	// EBhEp[^̐ݒ

	bool	CheckDevice();				// foCX̃`FbN

	bool	RestoreDevice();			// foCX̉
	void	OnLostDevice();				// ̃foCX̏
	void	OnResetDevice();			// ̃foCX̕

	LPDIRECT3D9			GetpD3D();		// Direct3D C^[tFCX̎擾
	LPDIRECT3DDEVICE9	GetpD3DDev();	// Direct3D foCX̎擾
	// Direct3D p[^̎擾
	void	GetD3DParam( D3DPRESENT_PARAMETERS &rD3DParam );		

	// _OEXe[g̐ݒ
	bool	SetRenderState( D3DRENDERSTATETYPE state, DWORD value );
	// eNX`̐ݒ
	bool	SetTexture( int n, LPDIRECT3DTEXTURE9 pTexture );
	// }eA̐ݒ
	bool	SetMaterial( D3DMATERIAL9 *pMaterial );

	CTextureManager		texture;
	CSpriteManager		sprite;	
	CDXSpriteManager	dxsprite;
	CFont				font;
	CCamera				camera;
	CXFileManager		xfile;
	CLightManager		light;
	CLine2D				line2d;

	friend class CApp;
	friend class CTextureManager;
	friend class CSpriteManager;	
	friend class CDXSpriteManager;
	friend class CFont;
	friend class CCamera;
	friend class CXFileManager;
	friend class CLightManager;
	friend class CLine;
};

extern CD3D d3d;

#endif