#ifndef _CFONT_H_
#define _CFONT_H_

#define DEF_FONT d3d.font.m_DefaultFont

//-----------------------------------------------------------------------------
// ChipSet :
// SHIFTJIS_CHARSET
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Name : FONTOBJ \
//-----------------------------------------------------------------------------
struct FONTOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : FONT_INFO NX
//-----------------------------------------------------------------------------
struct FONT_INFO
{
	LPD3DXFONT  pFont;	// tHgEC^[tFCX
	D3DXCOLOR	color;	// J[

	FONT_INFO();
	~FONT_INFO();
};

//-----------------------------------------------------------------------------
// Name : CFont NX
// Desc : tHg ֘Ȁs
//-----------------------------------------------------------------------------
class CFont
{
private:
	LPD3DXSPRITE	m_pSprite;				// XvCgEC^[tFCX
	CObjectArray <FONT_INFO> m_vInfo;

public:
	CFont();
	~CFont();

	FONTOBJ m_DefaultFont;							// ftHgtHg

	bool Init();									// 

	bool CheckObj( FONTOBJ obj );					// tHg̃`FbN
	
	bool Create( FONTOBJ &obj, int height, int width, 
		bool bold, bool italic, BYTE CharSet );				// tHg̍쐬
	bool Delete( FONTOBJ &obj );						// tHg̍폜

	bool Begin();		// tHg`̊Jn
	void End();			// tHg`̏I

	bool SetColor( FONTOBJ obj, D3DCOLOR color );				// F̐ݒ
	bool DrawText( FONTOBJ obj, int x, int y, char *str, ... );

	bool OnLostDevice();
	bool OnResetDevice();
};

#endif