#ifndef _CLIGHT_H_
#define _CLIGHT_H_

//-----------------------------------------------------------------------------
// Name : LIGOBJ \
//-----------------------------------------------------------------------------
struct LIGOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : LIGHT_INFO \
//-----------------------------------------------------------------------------
struct LIGHT_INFO {
	D3DLIGHT9	D3DLight;		// Cg
	bool		bEnable;		// CgON, OFF
};

//-----------------------------------------------------------------------------
// Name : CLightManager NX
// Desc : Cgs
//-----------------------------------------------------------------------------
class CLightManager
{
private:
	CObjectArray < LIGHT_INFO > m_vInfo;
	
	// Cg̐ݒ̍XV
	bool SetLight( LIGOBJ obj );

public:
	// Cg̐ݒ̍Ď擾
	void Restore();

	// Cg̍쐬
	bool Create( LIGOBJ &obj, D3DLIGHTTYPE type );
	// Cg̍폜
	bool Delete( LIGOBJ &obj );

	// Cg̗L
	bool SetEnable( LIGOBJ obj, bool bl );

	// Cg̎ނ̐ݒ
	bool SetType( LIGOBJ obj, D3DLIGHTTYPE type );
	// ft[YF̐ݒ
	bool SetDeffuse( LIGOBJ obj, float r, float g, float b, float a );
	// XyLF̐ݒ
	bool SetSpecular( LIGOBJ obj, float r, float g, float b, float a );
	// ArGgF̐ݒ
	bool SetAmbient( LIGOBJ obj, float r, float g, float b, float a );

	// Cg̈ʒu̐ݒ
	bool SetPos( LIGOBJ obj, float x, float y, float z );
	// Cg̐̕ݒ
	bool SetDirection( LIGOBJ obj, float x, float y, float z );
	// Cg̗L̐ݒ
	bool SetRange( LIGOBJ obj, float n );
	// Cg̃R[px̐ݒ
	bool SetConeAngle( LIGOBJ obj, float in, float out );

};

#endif