#ifndef _CMOUSE_H_
#define _CMOUSE_H_

typedef BYTE* MOUSEOBJ;	// }EXIuWFNg
#define MOUSE_MAX 8	// }EX̃{^̐
#define MOUSE_BUFFER_SIZE 16	// }EXobt@TCY

// }EXE{^
enum MOUSE_BUTTON {
	BUTTON_L = 0,
	BUTTON_R,
	BUTTON_C,
	BUTTON1	 = 0,
	BUTTON2,
	BUTTON3,
	BUTTON4,
	BUTTON5,
	BUTTON6,
	BUTTON7,
	BUTTON8,
};

// }EẌړ
enum MOUSE_MOVE {
	MOUSE_X,
	MOUSE_Y,
	MOUSE_C
};

//-----------------------------------------------------------------------------
// Name : CMouse NX
// Desc : }EXs
//-----------------------------------------------------------------------------
class CMouse
{
private:
	LPDIRECTINPUTDEVICE8	m_pMouseDev;	// }EXEfoCX
	DIDEVICEOBJECTDATA		m_Mouseod[MOUSE_BUFFER_SIZE];	// }EXʏ
	DIMOUSESTATE2			m_dims;			// }EX
	DWORD					m_dwItems;		// }EX̓͏

	SIZE	m_MousePos;						// }EX̍W
	long	m_MoveBuf[3];					// }EẌړ

	HANDLE	m_hMouseEvent;					// }EXCxg

public:
	CMouse();
	~CMouse();
	
	bool Create( HWND hWnd, LPDIRECTINPUT8 pDInput );	// 쐬
	bool SetState();					// }EX̏Ԃݒ
	void GetState( MOUSEOBJ &buf );		// }EX̏Ԃ擾
	void SetPos( int x, int y );		// }EẌʒuݒ
	void GetPos( SIZE &pos );			// }EẌʒu擾
	void Restore();						// foCX̍Ď擾

	void GetMove( long &n, MOUSE_MOVE move );	// }EẌړʂ̎擾
};

#endif