#ifndef _CTEXTURE_H_
#define _CTEXTURE_H_

//-----------------------------------------------------------------------------
// Name : TEXOBJ \
//-----------------------------------------------------------------------------
struct TEXOBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : TEXTURE_INFO \
//-----------------------------------------------------------------------------
struct TEXTURE_INFO {
	LPDIRECT3DTEXTURE9	pTexture;		// eNX`
	D3DXIMAGE_INFO		ImageInfo;		// C[W
	SIZE				TextureSize;	// eNX`ETCY

	TEXTURE_INFO();
	~TEXTURE_INFO();
};

//-----------------------------------------------------------------------------
// Name : FILTER_MODE 񋓑
//-----------------------------------------------------------------------------
enum FILTER_MODE {
	FILTER_NONE = D3DTEXF_NONE,
	FILTER_LINEAR = D3DTEXF_LINEAR
};

//-----------------------------------------------------------------------------
// Name : CTextureManager
// Desc : eNX`s
//-----------------------------------------------------------------------------
class CTextureManager
{
private:
	CObjectArray<TEXTURE_INFO> m_vInfo;
	
public:
	bool Check( TEXOBJ obj );	// eNX`̃`FbN
	bool Create( TEXOBJ &obj, const char *filename, D3DCOLOR Colorless = 0 );	// eNX`̍쐬
	bool Duplicate( TEXOBJ &obj1, TEXOBJ obj2 );		// eNX`̕
	bool Delete( TEXOBJ &obj );						// eNX`̍폜
	bool GetImageSize( SIZE &rSize, TEXOBJ obj );		// 摜TCY̎擾
	bool GetTextureSize( SIZE &rSize, TEXOBJ obj );	// eNX`ETCY̎擾

	LPDIRECT3DTEXTURE9  GetpTexture( TEXOBJ obj );	// eNX`̎擾

	void SetFilter( FILTER_MODE mode );				// tB^[
};

#endif