#include "DxApp.h"
#include "CMeteoStorm.h"

CMeteoStorm ms;

void CApp::Init()
{
	ms.InitApp();
}

void CApp::Main( HWND hWnd )
{
	ms.Init();	

	while( app.Loop() ) {

		if ( !ms.Act() ) return;

		//m_pD3DDev->SetSamplerState( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_BORDER );

		d3d.ClearScene( COLOR_XRGB( 0, 0, 255 ) );
		
		if ( d3d.Begin() ) {

			ms.Draw();

			if ( d3d.font.Begin() ) {
				d3d.font.End();
			}

			d3d.Render();
		}
	}
}

// bZ[W
void CApp::MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch ( msg )
	{
	case WM_KEYDOWN:
		switch( wParam ) {
		case '1':
			app.ChangeWindowMode();
			break;
		}
	}
}