#pragma once

#include "DxApp.h"

#define MAX_ORIGINAL_SOUNDS 5
#define MAX_ONE_SOUNDS 20

enum SOUND_TYPE
{
	SND_BLAST,
	SND_BLAST2,
	SND_METEO,
	SND_MACHINGUN,
	SND_MISSILE
};

struct SOUND_OBJECT
{
	bool m_bActive;
	SNDOBJ m_Sound;
	SOUND_TYPE type;
};

class CGameSound
{
public:
	CGameSound();
	virtual ~CGameSound() {};

	void Init();
	bool Act();
	bool Add( SOUND_TYPE type );

private:
	int GetEmptyObjectIndex( SOUND_TYPE type );
	
	int m_MaxSoundType;
	SOUND_OBJECT m_SoundObjects[MAX_ORIGINAL_SOUNDS][MAX_ONE_SOUNDS];
};