#include "CMeteoStorm.h"

CMeteoStorm::CMeteoStorm()
{
	m_pShip		= 0;
	m_pShots	= 0;
	m_pBG		= 0;
	m_pEnemies	= 0;
	m_pBlast	= 0;
	m_pSound	= 0;
	m_pScore	= 0;
}

CMeteoStorm::~CMeteoStorm()
{
	if ( m_pShip ) delete m_pShip;
	if ( m_pShots ) delete m_pShots;
	if ( m_pBG ) delete m_pBG;
	if ( m_pEnemies ) delete m_pEnemies;
	if ( m_pBlast ) delete m_pBlast;
	if ( m_pSound ) delete m_pSound;
	if ( m_pScore ) delete m_pScore;
}

void CMeteoStorm::InitApp()
{
	app.SetClientSize( SCREEN_WIDTH, SCREEN_HEIGHT );
	app.SetWindowTitle( "eIXg[" );
	app.SetVSyncEnable( false );

	srand( (unsigned int) time( 0 ) );
}

void CMeteoStorm::Init()
{
	m_pShip = new CShip();
	m_pShots = new CShots();
	m_pBG = new CBG();
	m_pEnemies = new CEnemies();
	m_pBlast = new CBlast();
	m_pSound = new CGameSound();
	m_pScore = new CScore();
}

bool CMeteoStorm::Act()
{
	KEYOBJ Key;
	input.key.GetState( Key );

	// 莞ԂœGo
	static float EWaitTime;
	if ( (EWaitTime += FTIME * 100) > 200 ) {
		 EWaitTime = 0;
		 int x = rand() % SCREEN_WIDTH;
		 int vx = -50 + rand() % 100;
		 int vy = 50 + rand() % 50;
		 // Gǉ
		 m_pEnemies->Add( x, -50, vx, vy, 0 );
	}

	// 莞ԂŔwi̐o
	static float SWaitTime;
	if ( (SWaitTime += FTIME * 100) > 20 ) {
		 SWaitTime = 0;
		 m_pBG->AddStar();
	}

	static bool bGameOver = false;	// Q[I[o[tO
	
	// e
	m_pShots->Act();
	if(	!m_pShip->Act( Key, m_pShots, m_pBlast, m_pEnemies, m_pSound, m_pScore ) )
		bGameOver = true;
	m_pEnemies->Act( m_pShip, m_pShots, m_pBlast, m_pSound, m_pScore );
	m_pBlast->Act();
	m_pBG->Act();
	m_pSound->Act();

	// Q[I[o[
	if ( bGameOver ) {
		int score = m_pScore->GetScore();
		char *str;
		if ( score < 50 ) str = "߂ہiGLDM)\n̍F_l";
		else if ( score < 100 ) str = "܂܂@((G߄D)\n̍Fʐl";
		else if ( score < 200 ) str = "(߁)>bII\n̍FKL叫";
		else if ( score >= 200 ) str = " YYYYY(A)!!!\n̍F}X^[";
		MesBox("[ނ[΁[", "XRA = %d\n%s", score, str );
		return false;
	}

	return true;
}

void CMeteoStorm::Draw()
{
	d3d.texture.SetFilter( FILTER_LINEAR );

	// e`揈
	m_pBG->Draw();
	m_pShip->Draw();
	m_pShots->Draw();
	m_pEnemies->Draw();
	m_pBlast->Draw();
	m_pScore->Draw();
}
