#include "CScore.h"

CScore::CScore()
{
	m_ScoreModels[0].LoadImage( "pictures/number.png" );
	for ( int i = 0; i < 10; i++ ) {
		m_ScoreModels[i].DuplicateImage( m_ScoreModels[0] );
		m_ScoreModels[i].SetTextureRect( i*21, 0, 21, 31 );
	}

	Init();
}

void CScore::Init()
{
	m_ScoreObject.m_Score = 0;
	m_ScoreObject.m_Pos.x = SCREEN_WIDTH - 50;
	m_ScoreObject.m_Pos.y = 0;

	m_LifeObject.m_Pos.x = 100;
	m_LifeObject.m_Pos.y = 0;
	m_LifeObject.m_Score = 3;
}

bool CScore::AddScore( int score )
{
	m_ScoreObject.m_Score += score;

	return true;
}

bool CScore::SetScorePos( float px, float py )
{
	m_ScoreObject.m_Pos.x = px;
	m_ScoreObject.m_Pos.y = py;

	return true;
}

bool CScore::AddLife( int life )
{
	m_LifeObject.m_Score += life;

	return true;
}

void CScore::Draw()
{
	for ( int i = 0; i < 2; i++ ) {
		SCORE_OBJECT *pObj;
		if ( i == 0 ) pObj = &m_ScoreObject;
		else if ( i == 1 ) pObj = &m_LifeObject;

		RECT rect = m_ScoreModels[0].GetTextureRect();
		int Score = pObj->m_Score;
		int n;
		int px = 0;

		do {
			n = Score % 10;
			m_ScoreModels[n].Draw( pObj->m_Pos.x + px, pObj->m_Pos.y );
			px -= rect.right;
			Score /= 10;
		} while ( Score > 0 );
	}
}
