#pragma once

#include "DxApp.h"
#include "GameSetting.h"
#include "CModel.h"

#define MAX_SCORE_OBJECTS 10

struct SCORE_OBJECT
{
	D3DXVECTOR2 m_Pos;
	int m_Score;
};

class CScore
{
public:
	CScore();
	virtual ~CScore() {};

	void Init();

	void Act();
	void Draw();
	bool AddScore( int score );
	bool SetScorePos( float px, float py );
	bool AddLife( int life );
	int GetLife() { return m_LifeObject.m_Score; }
	int GetScore() { return m_ScoreObject.m_Score; }

private:
	SCORE_OBJECT m_ScoreObject;
	SCORE_OBJECT m_LifeObject;

	CModel m_ScoreModels[10];
};