#include "CShip.h"
#include "CEnemies.h"

CShip::CShip()
{
	// 摜̓ǂݍ
	m_Models[0].LoadImage( "pictures/jet.png" );
	m_Models[1].DuplicateImage( m_Models[0] );
	m_Models[2].DuplicateImage( m_Models[0] );
	for ( int i = 0; i < 3; i++ ) {
		m_Models[i].SetTextureRect( i*32, 0, 32, 32 );	// UVݒ
		m_Models[i].SetScale( 2.0f, 2.0f );				// XP[O
		m_Models[i].SetHitRect( 9, 7, 13, 20 );			// 蔻̈
	}

	Init();	// 
}

bool CShip::Init()
{
	m_Pos.x = SCREEN_WIDTH / 2;
	m_Pos.y = SCREEN_HEIGHT - 100;
	m_fSpeed = 200;
	m_SelectedShotType = SHOT_MACHINEGUN;

	return true;
}

bool CShip::Act( const KEYOBJ &Key, CShots *pShots, CBlast *pBlast,
				 CEnemies *pEnemies, CGameSound *pSound, CScore *pScore )
{
	if ( Key[DIK_LEFT] == STATE_HOLD ) {
		if ( (m_Pos.x -= FTIME * m_fSpeed) < 0 ) m_Pos.x = 0;
		m_pSelectedModel = &m_Models[2];	// s@ɕύX
	}
	else if ( Key[DIK_RIGHT] == STATE_HOLD ) {
		if ( (m_Pos.x += FTIME * m_fSpeed) > SCREEN_WIDTH ) m_Pos.x = SCREEN_WIDTH;
		m_pSelectedModel = &m_Models[1];	// Es@ɕύX
	}
	else {
		m_pSelectedModel = &m_Models[0];	// Os@ɕύX
	}

	if ( Key[DIK_Z] == STATE_PUSH ) {
		switch ( m_SelectedShotType ) {
		case SHOT_MACHINEGUN: m_SelectedShotType = SHOT_MISSILE; break;
		default: m_SelectedShotType = SHOT_MACHINEGUN;
		}
	}

	static float fSpaceBuf;	// Xy[XL[pobt@
	if ( Key[ DIK_SPACE ] == STATE_HOLD ) { fSpaceBuf += FTIME * 100; }

	switch ( m_SelectedShotType ) {
	// 킪}VK̏ꍇ
	case SHOT_MACHINEGUN:
		if ( fSpaceBuf >= 30 ) {	// obt@30܂
			fSpaceBuf = 0;			// obt@NA
			pShots->AddPlayerShot( m_Pos.x - 15, m_Pos.y - 50 );	// 
			pSound->Add( SND_MACHINGUN );	// TEh
		}
		break;
	// 킪~TC̏ꍇ
	case SHOT_MISSILE:
		if ( fSpaceBuf >= 70 ) {	// obt@60܂
			fSpaceBuf = 0;			// obt@NA
			pShots->AddPlayerShot2( m_Pos.x - 15, m_Pos.y - 50 );	// 
			pSound->Add( SND_MISSILE );	// TEh
		}
		break;
	}

	static float NoHitBuf;	// Gԗpobt@
	if ( (NoHitBuf -= FTIME * 1000) > 0 ) {
		m_pSelectedModel->SetColor( BLEND_NORMAL, COLOR_XRGB(200,0,0) );
		return true;	// GԂ̊Ԃ߂
	}

	NoHitBuf = 0;	// obt@NA

	m_pSelectedModel->SetColor( BLEND_NORMAL, COLOR_XRGB(255,255,255) );

	// GƂ̓蔻
	if ( pEnemies->HitCheck( m_Pos.x, m_Pos.y, m_pSelectedModel->GetHitRect() ) ) {
		pScore->AddLife( -1 );								// Ct炷
		pBlast->Add( m_Pos.x, m_Pos.y, 1000.0f, 8.0f, 0 );	// V[
		NoHitBuf = 1000;	// GԂ0.5b
		if ( pScore->GetLife() <= 0 ) return false;	// CtȂȂ
	}

	return true;
}

bool CShip::Draw()
{
	m_pSelectedModel->Draw( m_Pos.x, m_Pos.y );

	return true;
}