#ifndef _CSOUND_READER_H_
#define _CSOUND_READER_H_

//-----------------------------------------------------------------------------
// Name : WAVEFILE_HEADER \
//-----------------------------------------------------------------------------
struct WAVEFILE_HEADER
{
  char         cRIFF[4];
  int          iSizeRIFF;
  char         cType[4];
  char         cFmt[4];
  int          iSizeFmt;
  char         cData[4];
  int          iSizeData;
};

//-----------------------------------------------------------------------------
// Name : CSoundReader NX
// Desc : TEh̓ǂݍݏs
//-----------------------------------------------------------------------------
class CSoundReader
{
private:
	WAVEFORMATEX	m_wfx;
	HMMIO			m_hmmio;
	MMCKINFO		m_mmckinfoWave;
	MMCKINFO		m_mmckinfoSub;
	DWORD			m_WaveSize;
	DWORD			*m_pWaveData;

	// OggVorbis p
	OggVorbis_File	m_OggFile;
	LONG			m_HeaderSize;	// wb_TCY
	LONG			m_DataSize;		// f[^TCYiwb_TCY܂܂ )
	int				m_iWord;		// ʎqoCg
public:
	CSoundReader();
	~CSoundReader();

	bool	WaveOpen( char *filename );
	bool	WaveRead( DWORD WaveSize = 0 );

	bool	OggOpen( char *filename );
	bool	OggRead( DWORD WaveSize = 0 ); // 0w肷

	DWORD			GetSize();		// TEhETCY̎擾
	WAVEFORMATEX	GetFormat();	// TEhEtH[}bg̎擾
	DWORD*			GetpData();		// TEhEf[^̎擾
};

#endif