#ifndef _CSPRITE_H_
#define _CSPRITE_H_

//-----------------------------------------------------------------------------
// Name : SPROBJ \
//-----------------------------------------------------------------------------
struct SPROBJ : public STDOBJ {
};

//-----------------------------------------------------------------------------
// Name : SPRITE_INFO
//-----------------------------------------------------------------------------
struct SPRITE_INFO {
	D3DXVECTOR2	pos;			// `ʒu
	TEXOBJ		TexObj;			// eNX`EIuWFNg
	RECT		TextureRect;	// eNX`ʒuATCY
	DWORD		UpLeftColor;	// F
	DWORD		UpRightColor;
	DWORD		LowRightColor;
	DWORD		LowLeftColor;
	float		angle;			// ]px
	D3DXVECTOR2	RotateCenter;	// ]̒S
	D3DXVECTOR2	scale;			// XP[
	D3DXVECTOR2 ScaleCenter;	// XP[̒S
	BLEND_MODE	blend;			// uh[h
	BOOL2		reverse;		// ]

	SPRITE_INFO();
	~SPRITE_INFO();
};

//-----------------------------------------------------------------------------
// Name : CSprite NX
//-----------------------------------------------------------------------------
class CSpriteManager
{
	CObjectArray < SPRITE_INFO > m_vInfo;

public:
	// XvCg̍쐬
	bool Create( SPROBJ &obj, char *filename, D3DCOLOR ColorKey = 0 );
	bool Create( SPROBJ &obj, TEXOBJ TexObj );
	bool Duplicate( SPROBJ &dest, SPROBJ source );			// 
	bool Draw( SPROBJ obj, float x, float y, float z = 0 );	// `
	bool Delete( SPROBJ &obj );								// 폜

	SPRITE_INFO* GetpSpriteInfo( SPROBJ obj );

	bool SetTextureRect( SPROBJ obj, int x, int y, int sizex, int sizey );
	bool GetTextureRect( SPROBJ obj, RECT &rect );
	bool SetRotate( SPROBJ obj, float angle, float cx, float cy );
	bool SetScale( SPROBJ obj, float x, float y, float cx, float cy );
	bool SetBlendColor( SPROBJ obj, BLEND_MODE mode, D3DCOLOR color );
	bool SetBlendColor( SPROBJ obj, BLEND_MODE mode, D3DCOLOR UpLeft, 
		D3DCOLOR UpRight, D3DCOLOR LowRight, D3DCOLOR LowLeft  );

	bool SetReverseTexture( SPROBJ obj, bool x, bool y );	// ]
};

#endif