#include "../Include/AppSystem.h"

CApp app;

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

//-----------------------------------------------------------------------------
// Name : ~CApp()
// Desc : fXgN^
//		  IuWFNg̊J
//-----------------------------------------------------------------------------
CApp::~CApp()
{
}

//-----------------------------------------------------------------------------
// Name : CApp()
// Desc : RXgN^
//		  IuWFNg̏
//-----------------------------------------------------------------------------
CApp::CApp()
{
	// EBhE֘Ȁ
	m_hWnd = 0;
	m_hMenu = 0;
	m_strWindowTitle = "";
	
	m_szWindowPos.cx = 100;
	m_szWindowPos.cy = 100;
	m_szClientSize.cx = 640;
	m_szClientSize.cy = 480;
	m_dwStyle = WS_OVERLAPPED | WS_CAPTION | 
		WS_SYSMENU | WS_MINIMIZEBOX;
	m_strClassName = "DirectXApplication";
	WNDCLASSEX wc = { sizeof( WNDCLASSEX ), CS_HREDRAW | CS_VREDRAW, WndProc, 
					  0, 0, 0, LoadIcon ( 0, IDI_APPLICATION ),
					  LoadCursor ( 0, IDC_ARROW ), 
					  ( HBRUSH ) GetStockObject( WHITE_BRUSH ),
					  0, m_strClassName, LoadIcon( 0, IDI_APPLICATION ) };
	m_wc = wc;

	m_bWindowMode	= true;
}

//-----------------------------------------------------------------------------
// Name : Create()
// Desc : EBhE̍쐬
// Rtn  : true  = 
//		  false = s
//-----------------------------------------------------------------------------
bool CApp::Create( HINSTANCE hInstance )
{
	// łɃEBhEĂI
	if ( m_hWnd != 0 ) return false;

	// EBhEENX̓o^
	m_wc.hInstance = hInstance;
	RegisterClassEx( &m_wc );

	// EBhEENg̎擾
	RECT rect = { 0, 0, m_szClientSize.cx, m_szClientSize.cy };
	AdjustWindowRect( &rect, m_dwStyle, m_hMenu ? true : false );
	m_szWindowSize.cx = rect.right	- rect.left;
	m_szWindowSize.cy = rect.bottom	- rect.top;

	// EBhE̍쐬
	m_hWnd = CreateWindow( m_strClassName, m_strWindowTitle, m_dwStyle,
						   m_szWindowPos.cx, m_szWindowPos.cy,
						   m_szWindowSize.cx, m_szWindowSize.cy, 
						   0, 0, hInstance, 0 );

	// Direct3D ̏
	if ( !d3d.Create( m_hWnd, m_szClientSize.cx, m_szClientSize.cy, 0,
		m_bWindowMode ) )
		return false;

	return true;
}

//-----------------------------------------------------------------------------
// Name : Show()
// Desc : EBhE̕\
//-----------------------------------------------------------------------------
void CApp::Show()
{
    ShowWindow( m_hWnd, SW_SHOWDEFAULT );
    UpdateWindow( m_hWnd );

	if ( !m_bWindowMode ) {
//		::SetMenu( m_hWnd, 0 );	// j[
		::SetWindowLong( m_hWnd, GWL_STYLE, WS_POPUP | WS_VISIBLE );
	}
}

//-----------------------------------------------------------------------------
// Name : Loop()
// Desc : bZ[WE[v
//		  ߂l true ̏ꍇAvÕCֈڂB
//		  ߂l false ̏ꍇAvOIB
// Rtn  : WM_QUIT ꍇ false
//				  ȊȌꍇ true  Ԃ
//-----------------------------------------------------------------------------
bool CApp::Loop()
{
	static MSG msg;
	do {
		if ( PeekMessage( &msg, 0, 0, 0, PM_REMOVE ) ) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else {
			Sleep( 1 );
			if ( !d3d.CheckDevice() ) continue;

			static bool bCW = true;
			if ( bCW == false ) d3d.m_bChangeWindow = false; bCW = true;
			if ( d3d.m_bChangeWindow ) bCW = false;

			app.fps.CountFPS();		// FPS̃JEg
			input.key.SetState();	// L[̏Ԃ̐ݒ
			input.mouse.SetState();	// }EX̏Ԃ̐ݒ

			return true;
		}
	} while ( msg.message != WM_QUIT );

	return false;
}

//-----------------------------------------------------------------------------
// Name : SetWindowTitle()
// Desc : ^Cg̐ݒ
// Argu : pTitle = ^Cg̃|C^
//-----------------------------------------------------------------------------
void CApp::SetWindowTitle( const char *pTitle )
{
	m_strWindowTitle = pTitle;
}

//-----------------------------------------------------------------------------
// Name : GetWindowTitle()
// Desc : ^Cg̎擾
//-----------------------------------------------------------------------------
void CApp::GetWindowTitle( const char* &prTitle )
{
	prTitle = m_strWindowTitle;
}

//-----------------------------------------------------------------------------
// Name : SetWindowStyle()
// Desc : X^C̐ݒ
// Argu : style = EBhEEX^C
//-----------------------------------------------------------------------------
void CApp::SetWindowStyle( DWORD style )
{
	m_dwStyle = style;
}

//-----------------------------------------------------------------------------
// Name : GetWindowStyle()
// Desc : X^C̎擾
//-----------------------------------------------------------------------------
void CApp::GetWindowStyle( DWORD &rStyle )
{
	rStyle = m_dwStyle;
}

//-----------------------------------------------------------------------------
// Name : SetClientSize()
// Desc : NCAgETCY̐ݒ
// Argu : x = X TCY
//		  y = Y TCY
//-----------------------------------------------------------------------------
void CApp::SetClientSize( int x, int y )
{
	m_szClientSize.cx = x;
	m_szClientSize.cy = y;
}

//-----------------------------------------------------------------------------
// Name : GetClientSize()
// Desc : NCAgETCY̎擾
//-----------------------------------------------------------------------------
void CApp::GetClientSize( SIZE &rSize )
{
	rSize.cx = m_szClientSize.cx;
	rSize.cy = m_szClientSize.cy;
}

//-----------------------------------------------------------------------------
// Name : SetWindowPos()
// Desc : EBhEE|WV̐ݒ
// Argu : x = X TCY
//		  y = Y TCY
//-----------------------------------------------------------------------------
void CApp::SetWindowPos( int x, int y )
{
	m_szWindowPos.cx = x;
	m_szWindowPos.cy = y;
}

//-----------------------------------------------------------------------------
// Name : GetWindowPos()
// Desc : EBhEE|WV̐ݒ
//-----------------------------------------------------------------------------
void CApp::GetWindowPos( SIZE &rSize )
{
	rSize.cx = m_szWindowPos.cx;
	rSize.cy = m_szWindowPos.cy;
}

//-----------------------------------------------------------------------------
// Name : SetWindowMode()
// Desc : EBhEE[h̐ݒ
// Argu : mode
//			true  : EBhE
//			false : tXN[
//-----------------------------------------------------------------------------
void CApp::SetWindowMode( bool mode )
{
	m_bWindowMode = mode;
}

//-----------------------------------------------------------------------------
// Name : GetWindowMode()
// Desc : EBhEE[h̎擾
//-----------------------------------------------------------------------------
void CApp::GetWindowMode( bool &rMode )
{
	rMode = m_bWindowMode;
}

//-----------------------------------------------------------------------------
// Name : GethWnd()
// Desc : EBhEEnh̎擾
//-----------------------------------------------------------------------------
void CApp::GethWnd( HWND &rhWnd )
{
	rhWnd = m_hWnd;
}

//-----------------------------------------------------------------------------
// Name : ResizeWindow()
// Desc : EBhEETCYύXꂽƂ̏
//-----------------------------------------------------------------------------
void CApp::ResizeWindow()
{
	RECT rect = { 0, 0, m_szClientSize.cx, m_szClientSize.cy };
	AdjustWindowRect( &rect, m_dwStyle, m_hMenu ? true : false );
	m_szWindowSize.cx = rect.right - rect.left;
	m_szWindowSize.cy = rect.bottom - rect.top;

	// obNobt@ETCY̐ݒ
	d3d.SetBackBufferSize( m_szClientSize.cx, m_szClientSize.cy );
	// Direct3D p[^̐ݒ
	d3d.SetWindowParam( m_bWindowMode );
	// foCX̕
	d3d.RestoreDevice();
}

//-----------------------------------------------------------------------------
// Name : ChangeWindowSize()
// Desc : EBhEETCY̕ύX
//-----------------------------------------------------------------------------
void CApp::ChangeWindowSize()
{
	ResizeWindow();

	if ( m_bWindowMode ) {
		::SetWindowLong( m_hWnd, GWL_STYLE, m_dwStyle | WS_VISIBLE );
		::SetWindowPos( m_hWnd, HWND_NOTOPMOST,
			m_szWindowPos.cx, m_szWindowPos.cy,
			m_szWindowSize.cx, m_szWindowSize.cy,
			SWP_SHOWWINDOW );
	}
	else {
		::SetWindowLong( m_hWnd, GWL_STYLE, WS_POPUP | WS_VISIBLE );
	}
}

//-----------------------------------------------------------------------------
// Name : ChangeWindowTitle()
// Desc : EBhEE^Cg̕ύX
//-----------------------------------------------------------------------------
void CApp::ChangeWindowTitle()
{
	SetWindowText( m_hWnd, m_strWindowTitle );
}

//-----------------------------------------------------------------------------
// Name : ChangeWindowMode()
// Desc : EBhEE[h̕ύX
//		  EBhEEp[^̕ύXōs
//-----------------------------------------------------------------------------
void CApp::ChangeWindowMode()
{
	m_bWindowMode = m_bWindowMode ? false : true;

	ChangeWindowSize();
}

//-----------------------------------------------------------------------------
// Name : SetVSyncEnable()
// Desc : Lɂ
// Argu : true =  L ( Default )
//		  false = 
//-----------------------------------------------------------------------------
void CApp::SetVSyncEnable( bool flag )
{
	d3d.m_bVSync = flag;
}

//-----------------------------------------------------------------------------
// Name : IsChangeWindow()
// Desc : EBhEύXꂽׂ
//		  EBhEύXꂽPt[ڂ̂trueԂ
//-----------------------------------------------------------------------------
bool CApp::IsChangeWindow()
{
	return d3d.m_bChangeWindow;
}
