#include "../Include/AppSystem.h"

CInput input;

//-----------------------------------------------------------------------------
// Name : CInput()
//-----------------------------------------------------------------------------
CInput::CInput()
{
	m_pDInput = 0;
}

//-----------------------------------------------------------------------------
// Name : ~CInput()
//-----------------------------------------------------------------------------
CInput::~CInput()
{
	RELEASE( m_pDInput );		// DirectInput IuWFNg
}

//-----------------------------------------------------------------------------
// Name : Init()
// Desc : DirectInput ̍쐬
// Argu : hWnd = EBhEEnh
//-----------------------------------------------------------------------------
bool CInput::Init( HWND hWnd, HINSTANCE hInst )
{
	HRESULT hr;
	hr = DirectInput8Create( hInst, DIRECTINPUT_VERSION, 
				IID_IDirectInput8, ( void** ) &m_pDInput, 0 );
	if ( FAILED( hr ) ) {
		MesBox( "G[", "DirectInput ̍쐬Ɏs܂" );
		return false;
	}

	if ( !key.Create( hWnd, m_pDInput ) ) {
		MesBox( "G[", "L[{[hEfoCX̍쐬Ɏs܂" );
	}

	if ( !mouse.Create( hWnd, m_pDInput ) ) {
		MesBox( "G[", "}EXEfoCX̍쐬Ɏs܂" );
	}
	
	return true;
}

//-----------------------------------------------------------------------------
// Name : Restore()
// Desc : ̓foCX̍Ď擾
//-----------------------------------------------------------------------------
void CInput::Restore()
{
	key.Restore();		// L[foCX̍Ď擾
	mouse.Restore();	// }EXfoCX̍Ď擾
}